<?
include "config.inc.php";
include "script/db.inc.php";
  
function ReverseGeocoding($latlon){
  global $GOOGLE_KEY, $GOOGLE_SRV_ADDR, $GOOGLE_SRV_PORT, $GOOGLE_SRV_TOUT;
  $fp = @fsockopen($GOOGLE_SRV_ADDR, $GOOGLE_SRV_PORT, $errno, $errstr, $GOOGLE_SRV_TOUT);
  if (!$fp) return 0;
  if($DEBUG) echo "Connessione con GOOGLE\t[OK]<br>";
  $GET_QUERY  = "GET /maps/geo?q=$latlon&output=csv&sensor=false&key=$GOOGLE_KEY&oe=utf-8 HTTP/1.1\r\n";
  $GET_QUERY .= "Host: $GOOGLE_SRV_ADDR\r\n";
  $GET_QUERY .= "User-Agent: Mozilla/5.0\r\n";
  $GET_QUERY .= "\r\n\r\n";
  @fputs($fp, $GET_QUERY, strlen($GET_QUERY));
  if($DEBUG) echo "Trasmissione con GOOGLE\t[OK]<br>";
  for ($i=0; $i<11; $i++) $BUFFER .=  fgets($fp, 1024);
  @fclose($fp);
  //Separo l'header
  $res = explode("\r\n\r\n", $BUFFER);
  if(count ($res)>0) 
    $BUFFER = $res[1];
    $res = explode("\"", $BUFFER);
    if(count ($res)>1) 
      return $res[1];
  return 0;
}

function GetTIMEZONE($lat,$lon){
  global  $WS_SRV_ADDR, $WS_SRV_PORT, $WS_SRV_TOUT;
  //http://ws.geonames.org/timezone?lat=47.01&lng=10.2
  //http://www.earthtools.org/timezone-1.1/47.01/10.2
  $fp = @fsockopen($WS_SRV_ADDR, $WS_SRV_PORT, $errno, $errstr, $WS_SRV_TOUT);
  if (!$fp) return 0;
  if($DEBUG) echo "Connessione\t[OK]<br>";
  $GET_QUERY  = "GET /timezone/$lat/$lon HTTP/1.1\r\n";
  //$GET_QUERY  = "GET /timezone?lat=$lat&lng=$lon HTTP/1.1\r\n";
  $GET_QUERY .= "Host: $WS_SRV_ADDR\r\n";
  $GET_QUERY .= "User-Agent: Mozilla/5.0\r\n";
  $GET_QUERY .= "\r\n\r\n";
  @fputs($fp, $GET_QUERY, strlen($GET_QUERY));
  for ($i=0; $i<16; $i++) $BUFFER .=  fgets($fp, 1024);
  @fclose($fp);
  //if(eregi("<rawOffset>([0-9]+).([0-9]+)</rawOffset>", $BUFFER, $ret)) {
  if(eregi("<offset>([0-9]+)</offset>", $BUFFER, $ret)) {
    return (int)$ret[1];
  }
  return 0;
}

function ShowError($ERR_MSG){
  echo "<center>";
  echo "<br><img src=\"./images/warning.png\">";
  echo "<p class=\"warning\">ERRORE<br><br>$ERR_MSG</p>";
  echo "</center>";
}

echo"<html>
  <head>
  <title>GlobaliX</title>
  <META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">
  <META HTTP-EQUIV=\"Cache-Control\" CONTENT=\"no-cache\">
  <link href=\"./style.css\" rel=\"stylesheet\" type=\"text/css\">
  </head>
  <body>";

if (!isset($_REQUEST[C])){
  ShowError("Cordinate non fornite");
  return 0;
}
//http://globalix.areasx.com/?C=
//ES: 4152.4419,N,01229.3738,E,126.5,0.33,151957.999,310309,PROVA                                                              
//LATITUDINE, N o S, LONGITUDINE, E o O, ALTITUDINE in mt,VELOCITA' in MIGLIA, TIME, DATA, IDENTIFICATIVO
$COORDINATE = explode(",", $_REQUEST[C]);
if(count ($COORDINATE)<9) {
  ShowError("Formato Cordinate non valido");
  return 0;
}
//Ricavo la latitudine
$latitude =(int)substr($COORDINATE[0],0,2) + (float)(substr($COORDINATE[0],2,7)) / 60; //Latitudine 
$latitude = substr($latitude,0,9);
$DIR_1 = $COORDINATE[1];
//Ricavo la longitudine
$longitude =(int)substr($COORDINATE[2],1,2) + (float)(substr($COORDINATE[2],3,7)) / 60; //Latitudine 
$longitude = substr($longitude,0,9);
$DIR_2 = $COORDINATE[3];
//Altitudine 
$ALTITUDE=$COORDINATE[4];
//Velocit
$SPEED=(int)$COORDINATE[5] * 1.609;

//ORARIO
//Booleano ora legale (1 se c' l'ora legale, 0 altrimenti)
//mktime(hour,minute,second,month,day,year,is_dst)
$timestamp= mktime(substr($COORDINATE[6],0,2),substr($COORDINATE[6],2,2),substr($COORDINATE[6],4,2),substr($COORDINATE[7],2,2),substr($COORDINATE[7],0,2) ,substr($COORDINATE[7],4,2));
$LEGAL = 0;
if(date("I", $timestamp)) $LEGAL = 1;
$TIMEZONE=GetTIMEZONE($latitude,$longitude);
$HOUR = (int)substr($COORDINATE[6],0,2) + $TIMEZONE + $LEGAL;
$TIME = $HOUR . ":" . substr($COORDINATE[6],2,2) . ":" . substr($COORDINATE[6],4,2);
if($TIMEZONE > 0){
  $TIMEZONE = "+$TIMEZONE";
}
//DATA
$DATE = substr($COORDINATE[7],0,2) . "/" . substr($COORDINATE[7],2,2) . "/20" . substr($COORDINATE[7],4,2);
//Identificativo
$IDENTIFY =$COORDINATE[8]; 


//Carica la cartina da GOOGLE
echo "<script language=\"javascript\">
  function ShowMAP(){
    var Width   = 640;
    var Height  = 640;
    if((document.body.clientWidth < 640) && (document.body.clientHeight < 640)){
      Width  =  document.body.clientWidth;
      Height = document.body.clientHeight;
    }
    window.document.getElementById('map').innerHTML = \"<img src='http://maps.google.com/staticmap?center=$latitude,$longitude&zoom=17&size=\" + Width + \"x\" + Height + \"&maptype=mobile\&markers=$latitude,$longitude&key=$GOOGLE_KEY&sensor=false'>\";
    return 0;
  }
</script>";



echo "<center>";
echo "<h2>GlobaliX II by Area SX</h2>";
echo "<table width=\"95%\" border=0>";
echo "<tr><td class=\"row_1\" width=\"50%\">Identificativo:</td><td class=\"row_2\" width=\"50%\">&nbsp;$IDENTIFY</td></tr>";
echo "<tr><td  class=\"row_1\">Data:</td><td class=\"row_2\">&nbsp;$DATE</td></tr>";
echo "<tr><td  class=\"row_1\">Ora:</td><td class=\"row_2\">&nbsp;$TIME (Timezone $TIMEZONE)</td></tr>";
echo "<tr><td colspan=\"2\"  class=\"row_1\">Coordinate</td></tr>";
echo "<tr><td class=\"row_1\">Latitudine: </td><td class=\"row_2\">&nbsp;$latitude $DIR_1 </td></tr>";
echo "<tr><td class=\"row_1\">Longitudine: </td><td class=\"row_2\">&nbsp;$longitude $DIR_2</td></tr>";
echo "<tr><td class=\"row_1\">Altitudine:</td><td class=\"row_2\">&nbsp;$ALTITUDE mt</td></tr>";
echo "<tr><td class=\"row_1\">Velocit:</td><td class=\"row_2\">&nbsp;$SPEED Km/h</td></tr>";
echo "<tr><td colspan=\"2\" class=\"row_1\">Indirizzo</td></tr>";
echo "<tr><td colspan=\"2\" class=\"row_2\">";
if(($RES=ReverseGeocoding($latitude . "," . $longitude))) 
  echo $RES;
else
  echo "Non disponibile";
echo "</td></tr>";
echo "<tr><td class=\"row_1\">Cartina</td><td class=\"row_2\">&nbsp;&nbsp;<INPUT TYPE=BUTTON VALUE=\"Visualizza\" onClick=\"javascript:ShowMAP(); return\"></td></tr>";
echo "<tr><td colspan=\"2\" align=\"center\">";
echo "<div id=map></div>";
echo "</td></tr>";
echo "</table>";
echo "</center>";

echo "<body>";
?>
